import numpy as np
import gym

from stable_baselines3 import DQN
from stable_baselines3.common.preprocessing import maybe_transpose
from stable_baselines3.common.utils import is_vectorized_observation
import qpd.networks.wrapper.stable_baselines.value_iteration as sbvi

from ..wrapper_decorator import wrapper

@wrapper
class WrapperDQN(sbvi.WrapperValueIteration):
    algorithm_type = DQN
    
    def forward(self, x):
        self.observation = x
        self.q_values = self.policy.q_net(self.observation)
        return self.q_values, None, None