from typing import Type, Union

import qpd.networks.wrapper.stable_baselines.sb_wrapper as sbw
from qpd.networks.wrapper.wrapper_decorator import wrapper

from qpd.networks.wrapper.model_wrapper import ModelWrapper
from stable_baselines3.sac.sac import SAC
import torch

class WrapperOFFPActorCritic(sbw.SBWrapper):
    def forward(self, obs):
        mean_actions, log_std, kwargs = self.policy.actor.get_action_dist_params(obs)
        self.actions = self.policy.actor.action_dist.actions_from_params(mean_actions, log_std, deterministic=self.config.evaluator_config.deterministic, **kwargs)

        value = torch.cat(self.policy.critic(obs, self.actions), dim=1)

        action_std = None

        if self.config.compression_config.distribution == "Std":
            action_std = torch.ones_like(mean_actions) * log_std.exp()

        return mean_actions, value, action_std
    
    def _get_actions(self):
        return self.actions
