from typing import Type
import torch as th
import torch.nn as nn
from gym import spaces 

from stable_baselines3.common.torch_layers import BaseFeaturesExtractor

from qpd.networks.wrapper.student.student_net import StudentNet

from ..student.cnn_student import CNNStudentNet
    
class SBStudentNet(BaseFeaturesExtractor):
    def __init__(self, observation_space: spaces.Space, features_dim: int = 16, network: Type[StudentNet]=CNNStudentNet):
        super(SBStudentNet, self).__init__(observation_space, features_dim)

        self.network = network(observation_space, features_dim)

        self._features_dim = self.network.features_dim

    def forward(self, observations: th.Tensor) -> th.Tensor:
        return self.network(observations)
