import numpy as np
import gym

from stable_baselines3.common.preprocessing import maybe_transpose
from stable_baselines3.common.utils import is_vectorized_observation

import qpd.networks.wrapper.stable_baselines.sb_wrapper as sbw

class WrapperValueIteration(sbw.SBWrapper):
    def _get_actions(self):
        if not self.config.evaluator_config.deterministic and np.random.rand() < self.config.evaluator_config.exploration_rate:
            if is_vectorized_observation(maybe_transpose(self.observation, self.policy.observation_space), self.policy.observation_space):
                if isinstance(self.policy.observation_space, gym.spaces.Dict):
                    n_batch = self.observation[list(self.observation.keys())[0]].shape[0]
                else:
                    n_batch = self.observation.shape[0]
                action = np.array([self.action_space.sample() for _ in range(n_batch)])
            else:
                action = np.array(self.action_space.sample())
        else:
            action = self.q_values.argmax(dim=1).reshape(-1)
        return action